//output pin supporting PWM, D3, D5, D6, D9, D10, D12
#include <MIDI.h>
MIDI_CREATE_DEFAULT_INSTANCE();
byte chn = 2; // midi channel
byte pushButton13 = 13; // midi gate IN
byte PadNota[36] = {36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71}; // 36 NOTES
byte nota = 0;
byte vela = 0;
byte PadNotb[36] = {36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71}; // 36 NOTES
byte notb = 0;
byte velb = 0;
boolean buttonState13 = 0;
boolean note13 = 0;

byte pwmPinXa = 10;   // output pin PWM cv1_a out
byte pwmPinYa = 12; // output pin PWM cv2_a out
byte gatePinZa = 9; // output pin Digital 9 gate out_a
byte ledZa = 11; // output pin Digital 11 gate out_a indicator
byte pwmPinXb = 5;   // output pin supporting PWM cv1_b out
byte pwmPinYb = 6; // output pin supporting PWM cv2_b out
byte gatePinZb = 7; // output pin Digital 7 gate out_b
byte ledZb = 8; // output pin Digital 8 gate out_b indicator

int valxa = 0; // variable to store the read value
int valya = 0;
int valza = 0;
int gateSa = 0;
byte resultxa = 0;
byte resultya = 0;
int resultza = 0;
int valxb = 0; // variable to store the read value
int valyb = 0;
int valzb = 0;
int gateSb = 0;
byte resultxb = 0;
byte resultyb = 0;
int resultzb = 0;

const int sPina = A0; // analog pin 0 Pot gate sensi a
const int xPina = A1;  // xa-axis of the accelerometer
const int zPina = A2;  // Za
const int yPina = A3;  // ya-axis
const int sPinb = A4; // analog pin 0 Pot gate sensi b
const int xPinb = A5;  // xb-axis of the accelerometer
const int zPinb = A6;  // Zb
const int yPinb = A7;  // yb-axis

void setup()
{
pinMode(pushButton13, INPUT);
pinMode(pwmPinXa, OUTPUT); // sets the pin as output
pinMode(pwmPinYa, OUTPUT); 
pinMode(ledZa, OUTPUT);
pinMode(gatePinZa, OUTPUT);
pinMode(pwmPinXb, OUTPUT); // sets the pin as output
pinMode(pwmPinYb, OUTPUT); 
pinMode(ledZb, OUTPUT);
pinMode(gatePinZb, OUTPUT);
MIDI.begin();
}

void loop()
{
buttonState13 = digitalRead(pushButton13);
valxa = analogRead(xPina); // read the input pin
valya = analogRead(yPina); 
valza = analogRead(zPina); 
gateSa = analogRead(sPina);
valxb = analogRead(xPinb);
valyb = analogRead(yPinb); 
valzb = analogRead(zPinb); 
gateSb = analogRead(sPinb);

nota = map (valxa, 262, 395, 0, 36);
vela = map (valya, 266, 396, 0, 127);
resultxa = map(valxa, 262 , 395, 0, 255); //min 262 max 395
resultya = map(valya, 266 , 396, 0, 255); //min 265 max 397
resultza = map(gateSa, 0 , 1023, 403, 667); // sensi Z a

notb = map (valxb, 262, 395, 0, 35);
velb = map (valyb, 266, 396, 0, 127);
resultxb = map(valxb, 262 , 395, 0, 255); 
resultyb = map(valyb, 266 , 396, 0, 255);
resultzb = map(gateSb, 0 , 1023, 403, 667); // sensi Z b

if (buttonState13 == HIGH) {
    if (note13 == 0) {
      MIDI.sendNoteOn(PadNota[nota], vela, chn);
      MIDI.sendNoteOn(PadNotb[notb], velb, chn+1);
      note13 = 1;
    }
  } else {
    if (note13 == 1) {
      MIDI.sendNoteOff(PadNota[nota], 0, chn);
      MIDI.sendNoteOff(PadNotb[notb], 0, chn+1);
    }
    note13 = 0;
  }
  
 if (valza >= resultza)
  {
    digitalWrite(ledZa, HIGH);
    digitalWrite(gatePinZa, HIGH);
    }
  else
  {
    digitalWrite(ledZa, LOW);
    digitalWrite(gatePinZa, LOW);
  }
  if (valzb >= resultzb)
  {
    digitalWrite(ledZb, HIGH);
    digitalWrite(gatePinZb, HIGH);
  }
  else
  {
    digitalWrite(ledZb, LOW);
    digitalWrite(gatePinZb, LOW);
  }

analogWrite(pwmPinXa, resultxa);
analogWrite(pwmPinYa, resultya);
analogWrite(pwmPinXb, resultxb);
analogWrite(pwmPinYb, resultyb);

delay(1);
}

