#include <MIDI.h>
#include <EEPROM.h>
MIDI_CREATE_DEFAULT_INSTANCE();
byte PadNote[36] = {36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71}; // 36 NOTES
byte note = 0;
byte velo = 0;
boolean buttonState13 = 0;
boolean note13 = 0;

byte resultx = 0;
byte resulty = 0;
int resultz = 0;

const byte chnBt = 3; //button channel select
boolean butChn; // button channel
const byte ledChn = 2; // blinking channel led
byte chn; // midi channel
int address = 1; // memmory channel

void setup()
{
pinMode(ledChn, OUTPUT);
pinMode(chnBt, INPUT_PULLUP);
chn = EEPROM.read(address);
delay (100);

if (chn == 0 || chn > 15) 
{
chn = 1;
EEPROM.write(address, chn);
delay(1000);
MIDI.begin(chn);
start (chn);
}
else
{
delay(1000);
MIDI.begin(chn);
bar (chn);
}  
}

void loop()
{
buttonState13 = digitalRead(13); // midi gate in

note = map (analogRead(A1), 262, 395, 0, 36); // x
velo = map (analogRead(A3), 266, 396, 0, 127); // y

resultx = map(analogRead(A1), 262 , 395, 0, 255); // x min 262 max 395
resulty = map(analogRead(A3), 266 , 396, 0, 255); // y min 265 max 397
resultz = map(analogRead(A0), 0 , 1023, 403, 667); // z sensi

butChn = digitalRead(chnBt); // button channnel select
	
	if (butChn == HIGH) // off (on) || HIGH on (off) 
      {
      chn+=1;
      if (chn <= 15)
      {
      EEPROM.write(address, chn);
      delay(500);
      MIDI.begin(chn);
      bar (chn);
      }
      if (chn >= 16)
      {
      chn = 1;
      EEPROM.write(address, chn);
      delay(500);
      MIDI.begin(chn);
      bar(chn);
      }
      }

if (buttonState13 == HIGH) {
    if (note13 == 0) {
      MIDI.sendNoteOn(PadNote[note], velo, chn);
      note13 = 1;
    }
  } else {
    if (note13 == 1) {
      MIDI.sendNoteOff(PadNote[note], 0, chn);
    }
    note13 = 0;
  }

if (analogRead(A2) >= resultz)
  {
    digitalWrite(11, HIGH); // gate out led
    digitalWrite(9, HIGH); // gate out pin
  }
  else
  {
    digitalWrite(11, LOW);
    digitalWrite(9, LOW);
  }
  
analogWrite(10, resultx); // pwm out cv1
analogWrite(12, resulty); // pwm out cv2
delay(1);
}
void start(byte chn)
{
    for (byte i=0; i<chn; i++) 
    {
    digitalWrite(ledChn, HIGH);
    delay(50);
    digitalWrite(ledChn, LOW);
    delay(400);
    loop();
    }
}
void bar(byte chn)
{
    for (byte i=0; i<chn; i++) 
    {
    digitalWrite(ledChn, HIGH);
    delay(50);
    digitalWrite(ledChn, LOW);
    delay(400);
    }
}

