//output pin supporting PWM, D3, D5, D6, D9, D10, D12
#include <MIDI.h>
#include <EEPROM.h>
MIDI_CREATE_DEFAULT_INSTANCE();
byte PadNota[36] = {36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71}; // 36 NOTES
byte nota = 0;
byte vela = 0;
byte PadNotb[36] = {36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71}; // 36 NOTES
byte notb = 0;
byte velb = 0;
boolean buttonState13 = 0;
boolean note13 = 0;

byte resultxa = 0;
byte resultya = 0;
int resultza = 0;

byte resultxb = 0;
byte resultyb = 0;
int resultzb = 0;

const byte chnBt = 3; //button channel select
boolean butChn; // button channel
const byte ledChn = 2; // blinking channel led
byte chn; // midi channel
int address = 1; // memmory channel

void setup()
{
pinMode(ledChn, OUTPUT);
pinMode(chnBt, INPUT_PULLUP);
chn = EEPROM.read(address);
delay (100);

if (chn == 0 || chn > 15) 
{
chn = 1;
EEPROM.write(address, chn);
delay(1000);
MIDI.begin(chn);
start (chn);
}
else
{
delay(1000);
MIDI.begin(chn);
bar (chn);
}  
}

void loop()
{
buttonState13 = digitalRead(13); // midi gate in

nota = map (analogRead(A1), 262, 395, 0, 36); // x a input
vela = map (analogRead(A3), 266, 396, 0, 127); // y a input
resultxa = map(analogRead(A1), 262 , 395, 0, 255); //x a min 262 max 395
resultya = map(analogRead(A3), 266 , 396, 0, 255); //y a min 265 max 397
resultza = map(analogRead(A0), 0 , 1023, 403, 667); // pot sensi Z a

notb = map (analogRead(A5), 262, 395, 0, 35); // x b input 
velb = map (analogRead(A6), 266, 396, 0, 127); // y b input
resultxb = map(analogRead(A5), 262 , 395, 0, 255); // x b min 262 max 395
resultyb = map(analogRead(A6), 266 , 396, 0, 255); //y b min 265 max 397
resultzb = map(analogRead(A4), 0 , 1023, 403, 667); // pot sensi Z b

butChn = digitalRead(chnBt); // button channnel select
	
	if (butChn == HIGH) // off (on) || HIGH on (off) 
      {
      chn+=1;
      if (chn <= 15)
      {
      EEPROM.write(address, chn);
      delay(500);
      MIDI.begin(chn);
      bar (chn);
      }
      if (chn >= 16)
      {
      chn = 1;
      EEPROM.write(address, chn);
      delay(500);
      MIDI.begin(chn);
      bar(chn);
      }
      }

if (buttonState13 == HIGH) {
    if (note13 == 0) {
      MIDI.sendNoteOn(PadNota[nota], vela, chn);
      MIDI.sendNoteOn(PadNotb[notb], velb, chn+1);
      note13 = 1;
    }
  } else 
  {
    if (note13 == 1) 
    {
      MIDI.sendNoteOff(PadNota[nota], 0, chn);
      MIDI.sendNoteOff(PadNotb[notb], 0, chn+1);
    }
    note13 = 0;
  }
  
 if (analogRead(A2) >= resultza) // z a input
  {
    digitalWrite(11, HIGH); // led a
    digitalWrite(9, HIGH); // gate a out
    }
  else
  {
    digitalWrite(11, LOW); // led a
    digitalWrite(9, LOW); // gate a out
  }
  if (analogRead(A6) >= resultzb) // z b input
  {
    digitalWrite(8, HIGH); // led b
    digitalWrite(7, HIGH); // gate b out
  }
  else
  {
    digitalWrite(8, LOW); // led b
    digitalWrite(7, LOW); // gate b out
  }

analogWrite(10, resultxa); // pwm x a out
analogWrite(12, resultya); // pwm y a out
analogWrite(5, resultxb); // pwm x b out
analogWrite(6, resultyb); // pwm y b out
delay(1);
}

void start(byte chn)
{
    for (byte i=0; i<chn; i++) 
    {
    digitalWrite(ledChn, HIGH);
    delay(50);
    digitalWrite(ledChn, LOW);
    delay(400);
    loop();
    }
}
void bar(byte chn)
{
    for (byte i=0; i<chn; i++) 
    {
    digitalWrite(ledChn, HIGH);
    delay(50);
    digitalWrite(ledChn, LOW);
    delay(400);
    }
}

